//forms
// assure les contrôles de champs 
// appelle un handler de calcul
// poste les données du formulaire
// permet d'afficher les résultats du handler de calcul si labels correspondant aux résultats existent dans le formulaire
// permet d'afficher les champs du formulaire avec un contenu fourni en entrée (datavalues en array javascript)
;(function($){
	$.fn.forms=function(o){
		return this.each(function(){
			var th=$(this)
				,_=th.data('forms')||{
					errorCl:'error',
					emptyCl:'empty',
					faultyCl:'faulty',
					invalidCl:'invalid',
					notkeyupCL:'notkeyup',
					notRequiredCl:'notRequired',
					successCl:'success',
					successafterCl:'successafter',
					successShow:'4000',
					mailHandlerURL:'', // fourni dans l'appel
					calculHandlerURL:'', // fourni dans l'appel
					ownerEmail:'par-defaut@domaine.com',
					stripHTML:true,
					smtpMailServer:'localhost',
					targets:'input,textarea,select',
					targetsonlytext:'input[type=text],input[type=date], input[type=tel],input[type=email],textarea,select',
					targetsCntl:'cntl',
					controls:'a[data-type=reset],a[data-type=submit], a[data-type=compute]',
					validate:true,
					checkboxCL: 'plxCheckbox', // identifie les checkbox
					radioCL: 'plxRadio', // identifie le bouton radio
					datepickerCL: 'plxForms_date', // identifie les dates saisies avec datepicjer de jquery
					calendarCL: 'plxdatmulti', // identifie les calendrier multi-date in-line de jquery
					pickoutCL : "plxPickout", // identifie les select utilisant le widjet pickout 
					slidepmCL : "plxSlidepm", // identifie les input utilisant le widjet slidepm 
					rx:{
						".name":{rx:/^[a-zA-ZÀ-ÿ'][a-zA-ZÀ-ÿ-' ]+[a-zA-ZÀ-ÿ']?$/,target:'input'},
						".firstname":{rx:/^[a-zA-ZÀ-ÿ'][a-zA-ZÀ-ÿ-' ]+[a-zA-ZÀ-ÿ']?$/,target:'input'},
						".email":{rx:/^(("[\w-\s]+")|([\w-]+(?:\.[\w-]+)*)|("[\w-\s]+")([\w-]+(?:\.[\w-]+)*))(@((?:[\w-]+\.)*\w[\w-]{0,66})\.([a-z]{2,6}(?:\.[a-z]{2})?)$)|(@\[?((25[0-5]\.|2[0-4][0-9]\.|1[0-9]{2}\.|[0-9]{1,2}\.))((25[0-5]|2[0-4][0-9]|1[0-9]{2}|[0-9]{1,2})\.){2}(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[0-9]{1,2})\]?$)/i,target:'input'},
						".phone":{rx:/(\+\d+(\s|-))?0\d(\s|-)?(\d{2}(\s|-)?){4}/,target:'input'},
//^[\+]?[(]?[0-9]{3}[)]?[-\s\.]?[0-9]{3}[-\s\.]?[0-9]{4,6}$
//						".phone2":{rx:/^\+(?:[0-9]●?){6,14}[0-9]$/,target:'input'},
// +3192030405 +3192 030405
						".phone2":{rx:/^\+(?:[0-9][-\x20\.]?){6,14}[0-9]$/,target:'input'},
//						".message":{rx:/.{20}/,target:'textarea'},
						".codepostal":{rx:/^[0-9']+[0-9']{4,}?$/,target:'input'},
						".date":{rx:/^(0[1-9]|[12][0-9]|3[01])[- /.](0[1-9]|1[012])[- /.](19|20)\d\d$/,target:'input'},
						".nombre":{rx:/^[0-9]+$/,target:'input'},
						".montant":{rx:/^[0-9]+([\.\,][0-9]{1,2})?$/,target:'input'},
					},
					attr : function(el, attr, value){
						if (typeof(value) == 'undefined') {
							return el.getAttribute(attr);
						}
						if (Array.isArray(el)) {
							el.forEach(function(element) {
							element.setAttribute(attr, value);	
						});
						return;
						}						
						el.setAttribute(attr, value);
					},
					preFu:function(){
						_.labels.each(function(){
							var label=$(this),
								elthis=this,
								inp=$(_.targets,this),
								defVal=inp.val(),
								trueVal=(function(){
											var tmp=(inp.is('input') || inp.is('select'))?(tmp=label.html().match(/value=['"](.+?)['"].+/),!!tmp&&!!tmp[1]&&tmp[1]):inp.html()
											return defVal==''?defVal:tmp
										})()
							trueVal!=defVal
								&&inp.val(defVal=trueVal||defVal)
							label.data({defVal:defVal})	
							inp
								.bind('focus',function(){
									inp.val()==defVal
										&&($(_.targetsonlytext,elthis).val(''),_.hideEmptyFu(label),label.removeClass(_.invalidCl),_.hideFaultyFu(label))
									_.calculFu(elthis.htmlFor, "focus")
								})
								.bind('blur',function(){
									label.hasClass(_.invalidCl)
										&&_.validateFu(label)									
									_.calculFu(elthis.htmlFor, "blur")
									if(_.isEmpty(label, elthis))
										inp.val(defVal)
										,_.hideErrorFu(label.removeClass(_.invalidCl))											
								})
								.bind('keyup',function(){
									label.hasClass(_.invalidCl)
										&&_.validateFu(label)
									if (!label.hasClass(_.notkeyupCL)) _.calculFu(elthis.htmlFor, "keyup")
								})
								elementmsg = label.find('.'+_.errorCl+',.'+_.emptyCl+',.'+_.faultyCl);
								elementmsg.css({display:'block'}).hide()

							if (_.isRequired(label)) {
								element = label.find('span').first()
								element.append("</span><span class='marque-data-obligatoire'>&#42;");
							}
						})
						_.success=$('.'+_.successCl,_.form).hide()
						_.successafter=$('.'+_.successafterCl,_.form).hide()
						_.setValToLabels(_.labels, _.datavalues, "101 Prefu")
					},
					isRequired:function(el){							
						return !el.hasClass(_.notRequiredCl)
					},
					ischeckbox:function(el, classwidget){ // retourne true si le champ a une class = "checkbox" 
						return el.find('select').hasClass(_.checkboxCL)
					},
					isradio:function(el){ // retourne true si le champ a une class = "radio" 
						return el.find('select').hasClass(_.radioCL)
					},
					ispickout:function(el){ // retourne true si le champ a une class = "popup select" 
						return el.find('select').hasClass(_.pickoutCL)
					},
					isslidepm:function(el){ // retourne true si le champ a une class = "input slide plus ou moins" 
						return el.find('select').hasClass(_.slidepmCL)
					},
					isdatepicker:function(el){ // retourne true si le champ a une class = "datepicker" 
						return el.find('input').hasClass(_.datepickerCL)
					},
					iscalendar:function(el){ // retourne true si le champ a une class = "calendrier" 
						return el.find('div').hasClass(_.calendarCL)
					},
					isValid:function(el){							
						var ret=true
						var matchone=false
						$.each(_.rx,function(k,d){
							if(el.is(k)){
//								if (k==".phone" || k==".phone2") {
//									console.log (k)
//									console.log (el.find(d.target).val())
//									if (d.rx.test(el.find(d.target).val())) console.log ("match")
//								}
								ret=matchone || d.rx.test(el.find(d.target).val())
								matchone=ret
							}
						})	
						return ret							
					},
					isVisible:function(el){
						var ret=true	
						if ( el.css('display') == 'none' || el.css("visibility") == "hidden"){
							ret=false
						}
						return ret	
					},
					isEmpty:function(el, elthis){
						var tmp
						(tmp=((el.find(_.targets).val())==el.data('defVal'))||tmp==el.data('defVal'))
						return tmp
					},
					isFaulty:function(el, elthis){ // basé sur la présence d'un contenu de span faulty sous le label
						var tmp
						tmp = false
						if (el.children('span.faulty').length >  0) {
							elementspan = el.children('span.faulty');
							if ($(elementspan).html() != '') {
									tmp = true;	
							}
						return tmp
						}
					},
					validateFu:function(el){
						el.each(function(){
							var th=$(this)
								,req=_.isRequired(th)
								,faulty=_.isFaulty(th, this)
								,empty=_.isEmpty(th, this)
								,valid=_.isValid(th)
								,visible=_.isVisible(th)
								,invalid=false
							if(empty&&req&&visible)
								{_.showEmptyFu(th.addClass(_.invalidCl))
								invalid=true
								}
							else 
								{_.hideEmptyFu(th)}
							if(faulty && !invalid) 
								{_.showFaultyFu(th.addClass(_.invalidCl))
								invalid=true
								}
							else 
								{_.hideFaultyFu(th)}
							if(!empty && !valid && visible)
								{_.showErrorFu(th.addClass(_.invalidCl))
								invalid=true
								}
							else 
								{_.hideErrorFu(th)}
							if (!invalid) th.removeClass(_.invalidCl)
						})
					},
					getValFromLabels:function(el, context){
						var fd = new FormData()
						el.each(function(){
							var th=$(this)
							var val=$(_.targets,th).val()
								,defVal=th.data('defVal')
							var value = th.length?val==defVal?defVal:val:'nope'  // si valeur par defaut on la transmet quand même
							// format des dates de la saisie JJ/MM/AAAA transformée en AAAA-MM-JJ
							if((value != "") && (th.is('.date'))) {
								var chunks = value.split('/');
								value = chunks[2]+'-'+chunks[1]+'-'+chunks[0];
							}
							if((value != "") && (th.hasClass('mteuro'))) {
								value = (value.toString()).replace(',', '.');
								value = value.replace(/ €/g, '');;
							}
							if (th.hasClass('daterange') && value !== "") {
								arraydates = value.split(","); // array of selected dates
								strDateFrom = arraydates[0];
								strDateTo = arraydates[arraydates.length - 1];
								arrayrange = [];

								iDateFrom = new Date(strDateFrom).getTime() / 1000;
								iDateTo = new Date(strDateTo).getTime() / 1000;
								if (iDateTo >= iDateFrom) {
									adddate = new Date(iDateFrom * 1000).toLocaleDateString('en-US', { month: '2-digit', day: '2-digit', year: 'numeric' }).replace(/\//g, '-')
									arrayrange.push(adddate); // first entry
									while (iDateFrom < iDateTo) {
									  iDateFrom += 86400; // add 24 hours
									  adddate = new Date(iDateFrom * 1000).toLocaleDateString('en-US', { month: '2-digit', day: '2-digit', year: 'numeric' }).replace(/\//g, '-')
									  arrayrange.push(adddate);
									}
								}
								newvalue =  arrayrange.join(",");
								cible =  ($(_.targets,th));
								if ($(cible[0]).is("input")) {$(cible[0]).val(newvalue);}
								if ($(cible[0]).is("input")) {_.attr(cible[0], "value", newvalue);}
							}
							var data = this.htmlFor
							fd.append(data, value);
//							if (data == "voie") console.log ("203 getval " + context + " " + data + " " + value);
//							if (data == "circuitduree1") console.log ("203 getval " + context + " " + data + " " + value);
//							if (data == "duree1") console.log ("203 getval " + context + " " + data + " " + value);
						})
						fd.append('num_mail', _.num_mail);
						fd.append('num_form', _.num_form);
						return fd
					},
					setValToSpanEmpty:function(el, spanclass, spanvalue){ // uniquement pour les span d'erreur empty
						elementspan = el.find('span.'+spanclass);
						if (spanvalue != "none") {
							$(elementspan).html(spanvalue);	
							_.showEmptyFu(el.addClass(_.invalidCl))
						}
						else {
							_.hideEmptyFu(el.removeClass(_.invalidCl))	
						};
						return true;
					},
					setValToSpanError:function(el, spanclass, spanvalue){ // uniquement pour les span d'erreur faulty
						elementspan = el.find('span.'+spanclass);
						if (spanvalue != "none") {
							$(elementspan).html(spanvalue);	
							_.showFaultyFu(el.addClass(_.invalidCl))
						}
						else {
							$(elementspan).html("");	// important car c'est la présence d'un contenu qui est testée par isfaulty
							_.hideFaultyFu(el.removeClass(_.invalidCl))	
						};
						return true;
					},
					setValToDisplay:function(selector, css, cssvalue){
//						select = $(selector).css({display:cssvalue});
						if (cssvalue == "reloaddatepicker") {
							_.initdatepicker("reset", "bind")
							return true
						}
						if (cssvalue == "none") {$(selector).slideUp('fast')}
						else {$(selector).slideDown('fast')}
						return true;
					},

					setValToDataAttribut:function(selector, css, cssvalue){
						th = $(selector);
						if (_.iscalendar(th) && css == "data" && cssvalue[0] == 'nbmonthsmin') {
								var cible =  ($(_.targets,th));
								var val=$(cible[0]).val()
									,defVal=th.data('defVal')
								var value = th.length?val==defVal?defVal:val:'nope'  // si valeur par defaut on la transmet quand même
								var minDate = new Date();
								minDate.setHours(0, 0, 0, 0);
								var nbmonthsmin = cssvalue[1];
								minDate.setMonth(minDate.getMonth() - nbmonthsmin); // date mini 
								var maxDate = new Date();
								maxDate.setHours(0, 0, 0, 0);
								var nbmonthsmax = th.data('nbmonthsmax');
								maxDate.setMonth(maxDate.getMonth() + nbmonthsmax); // date maxi 
								plxdatmulti.updated({
									resetDates : value,
									el:"#"+search+"-calendar",
									minDate : minDate,
									maxDate : maxDate

								});
						}
						return true;
					},
					setValToOptionSelected:function(selector, css, cssvalue){
						if (cssvalue == "selected") {_.attr($(selector), 'selected', 'selected');}
						else {
							($(selector)[0]).removeAttribute('selected');}
						return true;
					},
					setBindToLabel:function(select, search, newvalue){
						if (search == "compute") {
							_.calculFu("all", "compute")
						}
						else {
//							console.log (($(search)));
							if (newvalue == "focus") {$(search).focus();}
							if (newvalue == "blur") {$(search).blur();}
							if (newvalue == "click") {
								($(search))[0].click();
								} // simul de click sur une option
						}
						return true
					},
					setValToLabelSelect:function(select, search, newvalue, context){
						var texte = newvalue;
						newindex = 0;
						for (labelarray of select[0]) {
							if (newvalue == _.attr((select[0][newindex]), 'value')) {
							_.attr((select[0][newindex]), 'selected', 'selected');
							texte = (select[0][newindex]).innerHTML; // on récupére pour affichage le contenu du text de l'option et non la value
							}
						newindex +=1;
						}
						if ($(select[0]).hasClass('breaklineonslash')) {
							texte = texte.replace(" / ", "</br>"); 
						}
						// affichage du texte associé à l'option selected 
						// pour les  select class=plxPickout et  select class=plxSlidepm div est générée avec id = for du label
						// pour les select standard : pas de div, l'affichage est automatiquement le texte de l'option selected
						$('div[id='+search+']').html(texte);	
						newindex = 0;
						var selectspan = $(select.parent()).children("span"); // pour les select de type plxRadio ou plxCheckbox
						for (labelarray of selectspan) {
							// on deselectionne 
							if ($(labelarray).hasClass("pk-radio")) {
									$(labelarray).addClass("pk-radio-unselected");
									$(labelarray).removeClass("pk-radio-selected");
								}
							if ($(labelarray).hasClass("pk-checkbox")) {
									$(labelarray).addClass("pk-checkbox-unselected");
									$(labelarray).removeClass("pk-checkbox-selected");
								}
							// on selectionne 
						if (newvalue == _.attr(labelarray, 'value') || $(labelarray).hasClass(newvalue)) {
							if ($(labelarray).hasClass("pk-radio")) {
									$(labelarray).addClass("pk-radio-selected");
									$(labelarray).removeClass("pk-radio-unselected");
								}
							if ($(labelarray).hasClass("pk-checkbox")) {
									$(labelarray).addClass("pk-checkbox-selected");
									$(labelarray).removeClass("pk-checkbox-unselected");
								}
							}
						newindex +=1;
						}		
						return true
					},
					getMatchFromLabels:function(el, search){
						var valfind = ""
						el.each(function(){
							var th=$(this)
							var val=$(_.targets,th).val()
								,defVal=th.data('defVal')
							var value = th.length?val==defVal?'':val:'nope'
							var data = this.htmlFor
							if (data == search) {
								valfind = value
								return false
							}
						})
						return valfind
					},
					setValToLabels:function(el, datas, context){
						el.each(function(){
							var elthis = this
							var search = elthis.htmlFor 
							var th=$(this)
							var datas_el = datas.filter((check) => check[0] ==  search || check[0].startsWith("label[for='"+search+"'")) // WARNING no space in "label for" id
							for (labelarray of datas_el) {
								search = labelarray[0];
								newvalue = labelarray[1];
								if (Array.isArray(newvalue)) {
									if (newvalue[0] == "faulty")_.setValToSpanError(th, newvalue[0], newvalue[1] );
									if (newvalue[0] == "empty")_.setValToSpanEmpty(th, newvalue[0], newvalue[1] );
									if (newvalue[0] == "display")_.setValToDisplay(search, newvalue[0], newvalue[1] );
									if (newvalue[0] == "selected")_.setValToOptionSelected(search, newvalue[0], newvalue[1] );
									if (newvalue[0] == "data")_.setValToDataAttribut(search, newvalue[0], newvalue[1] );
								}
								else {
//									if (search == "duree1") {console.log ("332 setval " + context + " " + search + ' '  + " " + newvalue)};

									// format des dates en entrée : AAAA-MM-JJ transformée en JJ/MM/AAAA
									if (th.hasClass('date') && newvalue != "") {
										var chunks = newvalue.split('-');
										newvalue = chunks[2]+'/'+chunks[1]+'/'+chunks[0];
									}
									// format des montant euros en entrée : 123.45 transformée en 123,45 €
									if (th.hasClass('mteuro')) {
										newvalue = (newvalue.toString()).replace('.', ',') + " €";
									}
									cible =  ($(_.targets,th));
									if (newvalue == "focus" || newvalue == "blur" || newvalue == "click") {
										_.setBindToLabel (cible, search, newvalue)
									}
									else {
										if ($(cible[0]).is("input")) {$(cible[0]).val(newvalue);}
										if ($(cible[0]).is("input")) {_.attr(cible[0], "value", newvalue);}
										if ($(cible[0]).is("textarea")) {$(cible[0]).html(newvalue);}
										if ($(cible[0]).is("select")) {_.setValToLabelSelect(cible, search, newvalue, context);}
										if (newvalue != "") {_.hideEmptyFu(th);} // purge des éventuels messages emty
									}
								}
							}
						})
						return true
					},
					clearValFromLabelsSelect:function(el){
						clear = false;
						if ($("."+_.pickoutCL).length) { // test pour savoir si le select s'appuie sur le javascript pickout;
						pickout.empty({
							el:".plxPickout"
							});
						clear = true;
						}
						if ($("."+_.slidepmCL).length) { // test pour savoir si le select s'appuie sur le javascript plxSlidepm;
						slidepm.empty({
							el:".plxSlidepm"
							});
						clear = true;
						}
						if ($("."+_.radioCL).length) { // test pour savoir si le select s'appuie sur le javascript radioselect;
						radioselect.empty({
							el:".plxRadio"
							});
						clear = true;
						}
						if ($("."+_.checkboxCL).length) { // test pour savoir si le select s'appuie sur le javascript checkboxselect;
						checkboxselect.empty({
							el:".plxCheckbox"
							});
						clear = true;
						}
						if ($("."+_.datepickerCL).length) { // test pour savoir si un datepicker est présent;
						_.initdatepicker("clear", "clearValFromLabelsSelect")
						clear = true;
						}
						return clear;
					},
					clearValFromLabelsCalendar:function(el){
						clear = false;
						if ($("."+_.calendarCL).length) { // test pour savoir si un datepicker inline calendar est présenbt;
//						datas = _.getValFromLabels(_.labels, "S");
							_.labels.each(function(){
								var th=$(this)
								var cible =  ($(_.targets,th));
								if (_.iscalendar(th)) {
									var val=$(cible[0]).val()
										,defVal=th.data('defVal')
									var value = th.length?val==defVal?defVal:val:'nope'  // si valeur par defaut on la transmet quand même
									var minDate = new Date();
									minDate.setHours(0, 0, 0, 0);
									var nbmonthsmin = th.data('nbmonthsmin');
									minDate.setMonth(minDate.getMonth() - nbmonthsmin); // date mini 
									var maxDate = new Date();
									maxDate.setHours(0, 0, 0, 0);
									var nbmonthsmax = th.data('nbmonthsmax');
									maxDate.setMonth(maxDate.getMonth() + nbmonthsmax); // date maxi 
									plxdatmulti.updated({
										resetDates : value,
										el:"#"+this.htmlFor+"-calendar",
										minDate : minDate,
										maxDate : maxDate

									});
								}
							})
						clear = true;
						}
						return clear;
					},
					calculFu:function(datacall, context){
						var datas = _.getValFromLabels(_.labels, "410 CalculFu " + context)
						let different = false
						for (let [key, value] of datas.entries()) {
							if (olddatas.get(key) !== value) {
								different = true
								break
							}
						}
						if (!different && (datacall+'_'+context != "all_submit")){ // pas d'appel de calcul si les données sont idem celles du calcul précédent	sauf si submit final
							return
						}	
						olddatas = datas
						datas.append("context", datacall+'_'+context);
						_.maskPageOn("transparent");
						dataresult = switchJSAndCalcul.to({
								data: datas,
								formulaire : _.num_form
							});

						if (dataresult != false)  {
							_.maskPageOff();
							if (datacall == "bind" && context == "reset") _.showReset(datacall);
							_.setValToLabels(_.labels,dataresult, "420 calculFu " + datacall + " " + context);
							if (context == "reset")_.initdatepicker("reset", datacall);
							if (context == "submit") _.submitwhencalculFu();
						}
						else {
							$.ajax({
								type: "POST",
								url:_.calculHandlerURL,
								processData: false,
								contentType: false,
								data: datas,
								success: function(data, statut){ // success theroque, on regarde si mention de "calcul fait" dans data retournée
									if (data.indexOf ("calcul fait") > 0) { // alors le calcul est fait
									datas =  $.parseJSON(data)
									if (datacall == "bind" && context == "reset") _.showReset(datacall);
									_.setValToLabels(_.labels,datas, "420 calculFu " + datacall + " " + context)
									if (context == "reset")_.initdatepicker("reset", datacall)
									if (context == "submit") _.submitwhencalculFu()
									}
									else {
									_.showcalculEchec()	
									}
								},
								error: function(){ // echec du au serveur lui-même
									_.showcalculEchec()	
									}
							})
							_.maskPageOff();

						}
					},
					clearwaitFu:function(inst){
						_.success.text("");
						clearInterval(inst)
					},
					waitFu:function(textwait){
						_.success.slideDown()
						_.successafter.slideUp()
						var text = textwait;
						var counter = text.length;
						_.success.css("color", "green");
						_.success.text(textwait);
						var inst = setInterval(change, 200);
						return inst;
						
						function change() {
						text = text.padEnd(counter+2, ' .');
						_.success.text(text);
						counter+=2;
						if (counter >= 80) {
							counter = 0;
							text = textwait;
						}
						}
					},
					submitFu:function(){
						_.calculFu("all", "submit") // avec le context submit calculfu va faire la soumission finale en appelant submitwhencalculFu
					},
					submitwhencalculFu:function(){
						_.validateFu(_.labels)
						var datas = _.getValFromLabels(_.labels, "462 SubmitCalculFu")
						if(!_.form.has('.'+_.invalidCl).length)
						{	
							inst = _.waitFu(_.textewait)
							$.ajax({
								type: "POST",
								url:_.mailHandlerURL,
								processData: false,
								contentType: false,
								data: datas,
								success: function(obj, statut){ // success theroque, on regarde si mention de "mail sent" dans data retournée
									if( !('fail' in obj) ) { // alors le success est avéré
									_.clearwaitFu(inst)
									_.textsuccess = _.textsuccess
									_.textsuccessafter = obj.message
									_.showFu()
									}
									else {
									_.clearwaitFu(inst)
									_.textechec = obj.fail
									_.showEchec()	
//									console.log(data);
									}
								},
								error: function(jqXHR, exception){ // echec du au serveur lui-même	
									var msg = '';
									if (jqXHR.status === 0) {
										msg = 'Not connect.\n Verify Network.';
									} else if (jqXHR.status == 404) {
										msg = 'Requested page not found. [404]';
									} else if (jqXHR.status == 500) {
										msg = 'Internal Server Error [500].';
									} else if (exception === 'timeout') {
										msg = 'Time out error.';
									} else if (exception === 'abort') {
										msg = 'Ajax request aborted.';
									} else {
										msg = jqXHR.responseText;
									}
									_.textechechard = msg
									_.clearwaitFu(inst)
									_.showEchecHard()
									}
							})
						}
						else 
						{
							_.success.css("color", "red");
							_.success.text("Vérifiez les messages d'erreurs");
							_.success.slideDown(function(){
							setTimeout(function(){
								_.success.slideUp()
							},_.successShow)
						})
						}
					},
					showcalculFu:function(){
						_.success.css("color", "green");
						_.success.text("calcul fait");
						_.success.slideDown(function(){
							setTimeout(function(){
								_.success.slideUp()
							},_.successShow)
						})
					},
					showFu:function(){
						_.success.css("color", "green");
						_.success.text(_.textsuccess);
						_.success.slideDown(function(){		
							setTimeout(function(){
//								_.success.slideUp()
								_.form.trigger("reset")
								_.clearValFromLabelsCalendar(_.labels)
								_.clearValFromLabelsSelect(_.labels)
//								_.setValToLabels(_.labels, _.datavalues, "516 reset")
								_.calculFu("all", "reset")
							},_.successShow)
						})
						_.successafter.css("color", "green");
						_.successafter.text(_.textsuccessafter);
						_.successafter.slideDown();
					},
					showReset:function(datacall){
						_.success.css("color", "red");
						_.success.text("Effacement en cours");
						_.success.slideDown(function(){
							setTimeout(function(){
								_.success.slideUp()
							},1000)
						})
					},
					showcalculEchec:function(){
						_.success.css("color", "red");
						_.success.text("calcul KO");
						_.success.slideDown(function(){
							setTimeout(function(){
								_.success.slideUp()
							},_.successShow)
						})
					},
					showEchec:function(){
						_.success.css("color", "red");
						_.success.text(_.textechec);
						_.success.slideDown(function(){
						})
					},
					showEchecHard:function(){
						_.success.css("color", "red");
						_.success.text(_.textechechard);
						_.success.slideDown(function(){
						})
					},
					controlsFu:function(){
						$(_.controls,_.form).each(function(){
							var th=$(this)
							th
								.bind('click',function(){
									if (th.data('type') == "reset") {
										_.form.trigger(th.data('type'))
										_.clearValFromLabelsCalendar(_.labels)
										_.clearValFromLabelsSelect(_.labels)
										_.setValToLabels(_.labels, _.datavalues, "549 reset")
										_.calculFu("bind", "reset")
										}
									else 
									if (th.data('type') == "compute") {
										_.calculFu("bind", "compute")
									}
									else {
										_.form.trigger(th.data('type'))
									}
									return false
								})
						})
					},
					showErrorFu:function(label){
						label.find('.'+_.errorCl).slideDown('fast')
					},
					hideErrorFu:function(label){
						label.find('.'+_.errorCl).slideUp('fast')
					},
					showEmptyFu:function(label){
						label.find('.'+_.emptyCl).slideDown('fast')
						_.hideErrorFu(label)
					},
					hideEmptyFu:function(label){
						label.find('.'+_.emptyCl).slideUp('fast')
					},
					showFaultyFu:function(label){
						label.find('.'+_.faultyCl).slideDown('fast')
						_.hideErrorFu(label)
					},
					hideFaultyFu:function(label){
						label.find('.'+_.faultyCl).slideUp('fast')
					},
					ready:function(){
						_.form=_.me	
						_.form.ready(function(){
							_.init(_.me)
//							_.initdatepicker("ready", "ready")
							})
					},		
					init:function(){
						olddatas = new FormData();
						init = "YES";
						latency = 999;
						_.form=_.me		
						_.labels=$('label',_.form)
						_.clearValFromLabelsCalendar(_.labels)
						_.form.trigger('reset')
						_.clearValFromLabelsSelect(_.labels)
						_.preFu()
						_.controlsFu()	
						_.form
							.bind('submit',function(){
								if(_.validate)
									_.submitFu()
								else
									_.form[0].submit()
								return false
							})
							.bind('reset',function(){
								_.calculFu("init", "reset")
								_.labels.removeClass(_.invalidCl)									
								_.labels.each(function(){
									var th=$(this)
									_.hideErrorFu(th)
									_.hideEmptyFu(th)
									_.hideFaultyFu(th)
								})
							})
						_.form.trigger('reset')
					},
					maskPageOn:	function (color) { // color can be ie. 'rgba(176,176,176,0.7)' or 'transparent'
							if (init == "YES") {
								start = new Date().getTime()
								return
							}
							if (latency <= 0) {
								return
							}
							var div = $('.maskPageDiv');
							if (div.length === 0) {
								$(document.body).append('<div class="maskPageDiv loader"></div>'); // create it
								div = $('.maskPageDiv');
							}
							if (div.length !== 0) {
								div[0].style.zIndex = 2147483647;
								div[0].style.backgroundColor=color;
								div[0].style.display = 'inline';
							}
							$(".button-submit").addClass("disable-click");
					},
					maskPageOff: function () {
							if (init == "YES") {
								finish = new Date().getTime()
								latency = finish - start;
								init = "NO"
								return
							}
							if (latency <= 0) {
								return
							}							
							$('.maskPageDiv').remove();
							$(".button-submit").removeClass("disable-click");
					},
					initdatepicker:function(context, datacall){
						$('.'+_.datepickerCL).closest("label").each(function(){
							var th=$(this)
								var prefixe = this.htmlFor
								var	planningdata = _.getMatchFromLabels(_.labels, prefixe+"_planningdata")
								var	planningdata2 = _.getMatchFromLabels(_.labels, prefixe+"_planningdata2")
								var minDate = new Date();
								minDate.setHours(0, 0, 0, 0);
								var maxDate = new Date();
								maxDate.setHours(0, 0, 0, 0);
								var nbmonthsmin = th.data('nbmonthsmin');
								var nbmonthsmax = th.data('nbmonthsmax');
								minDate.setMonth(minDate.getMonth() - nbmonthsmin); // date mini 
								maxDate.setMonth(maxDate.getMonth() + nbmonthsmax); // date maxi 

								var disabledDays = planningdata.split(","); // les jours bloqués sous la forme MM-JJ-AAAA
								var BlueDays = planningdata2.split(","); // les jours affichés en bleu
								function disableAllTheseDays(date) {
									var m = date.getMonth(), d = date.getDate(), y = date.getFullYear();
									if(date < minDate) return [false, "datepickergrey"];
									if(date > maxDate) return [false, "datepickergrey"];
//									console.log (date + " / " + minDate);
									if($.inArray((m+1) + '-' + d + '-' + y,disabledDays) != -1) return [false, "datepickerred"];
									if($.inArray((m+1) + '-' + d + '-' + y,BlueDays) != -1) return [false, "datepickerblue"];
									return [true];
								}
								$("label[for='" + prefixe + "'] .plxForms_date").datepicker("destroy");
								$("label[for='" + prefixe + "'] .plxForms_date").datepicker({
									beforeShowDay: disableAllTheseDays,		
									todayHighlight: true,
									daysOfWeekHighlighted: [1, 2, 3, 4, 5],
									minDate: minDate, // on bloque en-deçà de cette date minDate
									maxDate: maxDate // on bloque en-delà de cette date maxDate

								}); 
						})
					}
				}
			typeof o=='object'
				&&$.extend(_,o)
			_.me||_.ready(_.me=th.data({forms:_}))
		})
	}
})(jQuery)