<?php
header('Content-Type: application/json');
set_time_limit(3300);
const PLX_ROOT = '../../../';
const PLX_CORE = PLX_ROOT .'core/';
define("L_SAVE_SUCCESSFUL",     "Enregistrement des données effectué avec succès");
define("L_SAVE_ERR",     "Erreur pendant l\'enregistrement des données");
if(!defined('PLX_CONFIG_PATH')) {
	include PLX_ROOT . 'config.php';
}
include_once PLX_CORE.'lib/config.php';
include_once PLX_CORE.'lib/class.plx.glob.php';
include_once PLX_CORE.'lib/class.plx.msg.php';
include_once PLX_CORE.'lib/class.plx.utils.php';
include_once PLX_CORE.'lib/class.plx.motor.php';
include_once PLX_CORE.'lib/class.plx.admin.php';
include_once PLX_CORE.'lib/class.plx.plugins.php';

$aResult = array();
$nblogline = 0;
$nbligparse = 0;
$plxAdmin = plxAdmin::getInstance();
$plugin = "plxGoaccess"; // le plugin nécessaire pour les mails
$plxPlugin = $plxAdmin->plxPlugins->getInstance($plugin);
$plxPlugin->setParam('Goaccessdate', $_POST["planning"], 'cdata'); // enregistrées dans les données de config du plugin
$plxPlugin->saveParams();
// if (isset($_GET['p']) && isset($_GET['next']) && $_GET['next']== 'Goaccess_logs') { // appel de la creation des logs
// lecture des logs selon les dates sélectionnées et stockage dans un seul et même fichier de log
// lecture des logs selon les dates sélectionnées et stockage dans un seul et même fichier de log
// pour chaque log (log journalière)
// - ligne acceptée si IP non exclue et si ne contient aucun bot reconnu et si contient requête / GET  à une des pages (cf sitemap) du site
//	$output=ob_get_clean();
$bot_list = $plxPlugin->getParam('bot_list'); // les bots à rechercher et à eliminer
$botlist = preg_split('/\n|\r/', $bot_list, -1, PREG_SPLIT_NO_EMPTY); // les bots à rechercher (présence du string dans la ligne de log)
if (count($botlist) === 0) {$botfilter = "N";} else {$botfilter = "Y";};
$site_pags_only = $plxPlugin->getParam('site_pags_only');
$mapcluster_radius = $plxPlugin->getParam('mapcluster_radius');
$dbmmdb = PLX_ROOT.$plxPlugin->getParam('data_mmdb');
$goacces_crawlers = $plxPlugin->getParam('goacces_crawlers');

$datfin = "2000-01-01";
$datdeb = "2099-12-31";
$logdate = explode (",", $_POST["planning"]); // on recupere les dates de log saisies 

// calcul des url du site
$xml = simplexml_load_file("../../../sitemap.xml");
$listurls = array();
foreach($xml->children() as $key => $children) {
	$url = parse_url($children->loc, PHP_URL_PATH);
	$listurls[] = $url;
}
// fin du calcul des url du site
$log_lines = PLX_ROOT.$plxPlugin->getParam('data_dir'). "/access.log"; // le fichier qui va recueillir toutes les lignes de log OK
if (file_exists ($log_lines)) unlink ($log_lines);
$handle_log_lines = fopen ($log_lines, 'x');
// debut de traitement pour une log (une date sélectionnée)
foreach($logdate as $datlog) 
{
	$dt = DateTime::createFromFormat("m-d-Y", $datlog);
	$dd = $dt->format("d");
	$mm = $dt->format("m");
	$yy = $dt->format("y");
	$yyyy = $dt->format("Y");
	$datAAMMJJ = $dt->format("Y-m-d");
	$datelogrec = $dt->format("d/M/Y");
	$log_env = PLX_ROOT.$plxPlugin->getParam('data_dir'). "/env.log"; // le fichier qui va recueillir toutes les lignes de log OK
	if (file_exists ($log_env)) unlink ($log_env);
	$handle_log_env = fopen ($log_env, 'x');
	fwrite($handle_log_env, "env = " . $_POST["env"]);
	fclose ($handle_log_env);
	if ($datAAMMJJ < $datdeb) $datdeb = $datAAMMJJ;
	if ($datAAMMJJ > $datfin) $datfin = $datAAMMJJ;
	$logfile = "https://".$_POST['passok']."@".$plxPlugin->getParam('log_url'); // recup de la description de l'URL d'une log depuis la config du plugin
	if ($_POST["env"] == "recette") $logfile = "http://192.168.1.25/data/goaccess/datas/accessrec.log";
	if ($_POST["env"] == "dev") $logfile = "http://localhost/data/geoip/accesslogdev.log";
	$logfile = str_replace ("%d%", $dd, $logfile);
	$logfile = str_replace ("%m%", $mm, $logfile);
	$logfile = str_replace ("%y%", $yy, $logfile);
	$logfile = str_replace ("%Y%", $yyyy, $logfile);
	$dirlog = "logs-" . $dt->format("m-Y");
try{
	if (!$handle = gzopen($logfile,'r')){
			throw new Exception('failed : log file access error ');
		}else{
		}
	}catch(Exception $e){
		$aResult['fail'] = $e->getMessage();
		echo json_encode($aResult);
		exit;
	}
	while (!feof($handle)) { // pour chaque line du fichier log
		$logLine = fgets($handle); 
		$nbligparse += 1;
		$urlmatch = false; // init
		if ($site_pags_only === 'Y') // option uniquement les lignes concernant les pages du sites ou bien toutes
			{
			foreach($listurls as $geturl) // boucle pour la recherche des urls du site dans la ligne de log
			{
				if (!(strpos($logLine, "GET " . $geturl . " ") === false)) // recherche dans ligne de log de la sequence GET /xxxx
				{
					$urlmatch = true;
					break; 
				}
			}	
			if (($urlmatch !== false) and ($goacces_crawlers == "--crawlers-only") and ($botfilter == "Y")) { // on filtre sur un ou les bots paramétrés
				$urlmatch = false;
				foreach($botlist as $botstring)
				{
					if (!(strpos(logLine, $botstring) === false)) {
						$urlmatch = true;
						break;
						};
				}
			}
		}
		else
		{
			$urlmatch = true; // on retient toutes les lignes dans le cas ou le paramètre ne prévoit pas que les urls des pages du site
		};	
		if ($urlmatch !== false) // on retient cette log line
		{
			try{
				if ((fwrite($handle_log_lines, $logLine)) === false){
					throw new Exception('failed : write  acces.log');
				}else{
					$nblogline += 1;
				}
				}catch(Exception $e){
					$aResult['fail'] = $e->getMessage();
					echo json_encode($aResult);
					exit;
				}
		};
	};
	fclose($handle);
	};
fclose ($handle_log_lines);
$dt = DateTime::createFromFormat("Y-m-d", $datdeb);
$datdeb = $dt->format("d-m-Y");
$dt = DateTime::createFromFormat("Y-m-d", $datfin);
$datfin = $dt->format("d-m-Y");
$acces_log_dates_file = PLX_ROOT.$plxPlugin->getParam('data_dir'). "/acces_log_dates.php";
$acces_log_dates = array();
$acces_log_dates[] = $datdeb;
$acces_log_dates[] = $datfin;
$plxPlugin->setParam('acces_log_dates', implode("\r", $acces_log_dates), 'cdata'); // enregistrées dans les données de config du plugin
$plxPlugin->saveParams();


// calcul du rapport
// execution de goaccess sous linux ou windows 
// la log analysée doit avoir été ramené localement (execution de :  Goaccess.php)
// l'execution sous windows nécessite d'activer wsl dans windows10 
// + installer debian à partir du microsoft store  
// + installer et compiler goacces dans debian avec  l'option --enable-geoip=mmdb
// + configurer le service apache windows pour le connecter à un compte avec droits admin
// + et vérifier que ce compte admin a bien les  path c:\windows\system32 ou mieux : %SystemRoot%\system32 en variables d'environnement systeme

$goacces_crawlers = $plxPlugin->getParam('goacces_crawlers');
$data_mmdb = $plxPlugin->getParam('data_mmdb');
$log_lines = $plxPlugin->getParam('data_dir'). "/access.log"; // le fichier contient toutes les lignes de log à anamyser
$path_goaccess = $plxPlugin->getParam('goaccess_dir'); // le path absolu Goaccess unix ou unix via wsl pour windows
$anonymize_ip = ' --anonymize-ip '; // option par defaut ==> inconvenient la location city de goaccess devient partiellement inexacte;
$path = $_SERVER['DOCUMENT_ROOT']; // pour definir les path absolus unix 
$path_report = '/' . $plxPlugin->getParam('data_dir') . '/report.html';
if (!defined('PHP_WINDOWS_VERSION_BUILD')) {
	// linux 
	$del = 'rm ' . $path . $path_report; // delete ancien rapport
	$cmd_run = ""; // execution du binaire sous unix
}
else
{
	// windows : activez wsl et charger une distribution debian avec microsoft store ==> c'est l'option ici
	$path = "/mnt/".str_replace ("C:", "c", $_SERVER['DOCUMENT_ROOT']); // path absolu pour l'environnement linux sous windows
	$del = 'del ' . str_replace('/', '\\', $_SERVER['DOCUMENT_ROOT'] . $path_report); // delete ancien rapport avec path absolu windows (antislash)
	$cmd_run = "wsl sudo "; // execution du binaire goaccess à travers wsl 
	//putenv('PATH=' . $_SERVER['PATH']);
}
$option_goaccess  = $path . '/'. $log_lines .' --with-mouse --log-format='.$plxPlugin->getParam('regex_url').' --no-progress --geoip-database=' . $path . '/'. $data_mmdb. ' -o  ' . $path . $path_report . ' ' . $goacces_crawlers . ' ' . $anonymize_ip;
$cmdgoaccess = $path_goaccess . ' ' . $option_goaccess; // attention : il faut que le service apache windows soit connecté sur un compte admin exec($cmd);
$cmd = $cmd_run . $cmdgoaccess;
exec($del);
// exec($cmd, $output, $retval);
//$cmd = 'c:\windows\system32\wsl.exe --help';
exec($cmd . " 2>&1", $output, $retval);

$data_dir = PLX_ROOT.$plxPlugin->getParam('data_dir');
$report_file = $data_dir. "/report.html";

if (!$retval == "0"){
	$handle_report = fopen ($report_file, 'x');
	fwrite($handle_report, "code retour de la commande = ". $retval . "<br/> essayez la commande ci-dessous dans un terminal puis afficher de nouveau les stats<br/>". $cmd);
};

try{
	if (!$retval == "0"){
			throw new Exception('failed Goaccess exec : '. '<br />'. implode ("<br />",$output));
		}else{
		}
}catch(Exception $e){
	$aResult['fail'] = $e->getMessage();
	echo json_encode($aResult);
	exit;
}
$aResult['result'] = "OK";
$aResult['message'] = $nblogline . " lignes de log analysées sur " . $nbligparse . " lignes de log lues";
echo json_encode($aResult);
?>