<?php
/**
 * Plugin plxGoaccess
 **/
class plxGoaccess extends plxPlugin {
	public $plugName;
	public $site_pags_only;
	public $goaccess_dir;
	public $data_dir;
	public $data_mmdb;
	public $log_url;
	public $exclude_IPs;
	public $goacces_crawlers;
	public function __construct($default_lang) {

		# appel du constructeur de la classe plxPlugin (obligatoire)admin
		parent::__construct($default_lang);
		$this->plugName = $this->plug['name'];

		# droits pour accéder à la page config.php du plugin
		$this->setConfigProfil(PROFIL_ADMIN);
		# droits pour accéder à la page admin.php du plugin
		$this->setAdminProfil(PROFIL_ADMIN ); // admin et gestionnaire
		# initialisation des variables de la classe
		$this->site_pags_only = $this->getParam('site_pags_only')!='' ? $this->getParam('site_pags_only').'/' : '';
		$this->goaccess_dir = $this->getParam('goaccess_dir')!='' ? $this->getParam('goaccess_dir').'/' : '';
		$this->data_mmdb = $this->getParam('data_mmdb')!='' ? $this->getParam('data_mmdb').'/' : '';
		$this->data_dir = $this->getParam('data_dir')!='' ? $this->getParam('data_dir').'/' : '';
		$this->log_url = $this->getParam('log_url')!='' ? $this->getParam('log_url').'/' : '';
		$this->exclude_IPs = $this->getParam('exclude_IPs')!='' ? $this->getParam('exclude_IPs').'/' : '';
		$this->goacces_crawlers = $this->getParam('goacces_crawlers')!='' ? $this->getParam('goacces_crawlers').'/' : '';
	}
   public function OnActivate() {
        # code à exécuter à l’activation du plugin
		$file_plugOnactivateConfig = (PLX_PLUGINS.$this->plugName.'/OnactivateConfig.xml');
		$file_plugConfig = (PLX_ROOT.PLX_CONFIG_PATH.'plugins/'.$this->plugName.'.xml');
		if (!file_exists(realpath($file_plugConfig)))
		{
			copy ($file_plugOnactivateConfig, $file_plugConfig); // init de la configuration par defaut
        }
	}
// $formulaire : 0, 1, 2 ... selon ce qui a été configuré dans le plugin
// $message_data : soit array vide et dans ce on prend ce qui est dans la configuration du formulaire 
// soit une array à deux entrée (tag1 => data1, tag2 => data2) tag1, tag2, .. sous la forme ##mot_clé## 
// et data1, data2, ... étant le contenu qui remplacera le ##mot_clé## dans le html ou les adresses eformulaire du formulaire
// $head_html : le html qui viendra en tête du html final  ; si vide on prend le head_html configuré
// $catId : n° de la categorie contenant les articles de la politique de confidentialité (si existe)
// $staticId : n° de la page statique affichant dans le site la politique de confidentialité (si existe)
// $standalone : true = le formulaire ne sera pas précédé du debut de page ni de la fin de page 
// datavalues : tableau des data:value à pré-afficher dans les zones input ou textarea ou select (data = label for, value = valeur)
public function Plxformulaires_Send($formulaire, $message="", $message_data=array(), $catId="", $staticId="", $head_html="", $standalone=true, $datavalues=array(), $mailHandlerURL= "", $calculHandlerURL="", $formscss = "")
{
	$versionsite = $this->getInfo('version');
	if ($mailHandlerURL == "") {$mailHandlerURL= PLX_PLUGINS.$this->plugName."/php/DefaultValidHandler.php";}
	if ($calculHandlerURL == "") {$calculHandlerURL= PLX_PLUGINS.$this->plugName."/php/DefaultCalculHandler.php";}
	if ($formscss == "") {$formscss= PLX_PLUGINS.$this->plugName.'/css/Forms.css?version=' . $versionsite ;}

	$num_mail = 0;
	if ($message == "") {$message = html_entity_decode($this->getParam($formulaire . '_message'));}; 
	$inline_imgs = $this->StringXMLToArray($this->getParam($formulaire . '_inline_imgs'));
	if ($staticId == "") {$staticId = $this->getParam($formulaire . '_staticId');};
	if ($catId == "") {$catId = $this->getParam($formulaire . '_catId');};
	if ($head_html == "") {$head_html = html_entity_decode($this->getParam($formulaire . '_head_html'));};
	$head_html = str_replace("PLX_PLUGINS", PLX_PLUGINS, $head_html);  // permet la déclaration de fichier css ou js présent dans le plugin
	if (empty($message_data)) {
		$message_data = $this->getParam($formulaire . '_message_data');
		$message_data = $this->StringXMLToArray($message_data);	
	}
	// tranformation de l'array PHP (data => value) en array JS pour pouvoir être traité par  forms.js
	// value peut etre une array telle data2 = > value2 et value2 peut être elle-même être une array
	$jsdatavalues = '[';
	$i = 1;
	foreach ($datavalues as $data => $value) {	// $value peut être une array 
		if ($i > 1) {$jsdatavalues .= ',';};
	//	$value = preg_replace('/\n|\r/', ' ', $value); // suppresion des éventuels line break
		if (is_array($value)) { // si $value est une array
			$valuearray = $value; 
			foreach ($valuearray as $value1 => $value2){
				$value1 = htmlspecialchars($value1);
				if (is_array($value2)) { // si $value2 est une array
					$valuearray2 = $value2;
					foreach ($valuearray2 as $value21 => $value22){
						$value21 = htmlspecialchars($value21);
						$value22 = htmlspecialchars($value22);
						$value2 = '["'.$value21.'", "'.$value22.'"]';
						$value = '["'.$value1.'", '.$value2.']';
					}
				}
				else {
					$value2 = htmlspecialchars($value2);
					$value = '["'.$value1.'", "'.$value2.'"]';
				}
			};
		}
		else {
			$value = htmlspecialchars($value);
			$value = '"'.$value.'"'; 
		};
		$jsdatavalues .= '["'.$data. '",' . $value . ']';
		$i +=1;
	}
	$jsdatavalues .= ']';
	$jsdatavalues = preg_replace('/\n|\r/', ' ', $jsdatavalues); // suppresion des éventuels line break

	// fin de la construction de l'array javascript des values à remplir dans les zones de saisie

	// on modifie la balise <form pour placer l'identifiant obligatoire PlxForm
	$array_form = $this->getContents($message, $startDelimiter="<form", $endDelimiter=">");
	$form_origine = '<form'.$array_form[0].'>';
	$form_cible = '<form id="PlxForm' . $formulaire . '" class="plxForms plxForms_custom">'; 
	$message = str_replace ($form_origine, $form_cible, $message);

	// on ajoute les lib jquery nécessaires
	$add_jquery= '
	<script src="https://ajax.googleapis.com/ajax/libs/jqueryui/1.8/jquery-ui.min.js"></script>
	<script type="text/javascript" src="'.PLX_PLUGINS.$this->plugName.'/js/Formscalcul_param.js?version=' . $versionsite.'"></script>
	';

	// on ajoute le fichier css pour le formulaire

	$add_css = '
	<link href="https://ajax.googleapis.com/ajax/libs/jqueryui/1.8/themes/base/jquery-ui.css" rel="stylesheet" type="text/css" />
	<link rel="stylesheet" href="'.$formscss.'" media="screen"/>
	';

	// on colle les morceaux 
	$message = $add_jquery . $add_css . $message;

	// traitement de la mention RPGD 
	$existRPGD = false;
	$plxMotor = plxMotor::getInstance();
	$staticId = str_pad($staticId,3,"0", STR_PAD_LEFT);
	$catId = str_pad($catId,3,"0", STR_PAD_LEFT);
	if(isset($plxMotor->aStats[$staticId])) {
	// une statique "politique de confidentialité est déclarée : on affiche cette statique
		$url = $plxMotor->urlRewrite('?static'.ltrim($staticId, "0").'/'.$plxMotor->aStats[$staticId]['url']);
		$title = plxUtils::strCheck($plxMotor->aStats[$staticId]['name']);
		$existRPGD = true; 
	}
	else {
		if(isset($plxMotor->aCats[$catId])) {
	// une catégorie contenant les articles de  "politique de confidentialité est déclarée : on affiche cette catégorie
			$url = $plxMotor->urlRewrite('?categorie'.ltrim($catId, "0").'/'.$plxMotor->aCats[$catId]['url']);
			$title = plxUtils::strCheck($plxMotor->aCats[$catId]['name']);
			$existRPGD = true;
		}
	}
	if ($existRPGD) {
		$add_js_newwindows = ' 
		<script type="text/javascript"> 
		$(document).ready(function(){
		$("#RGPD").click(function(){
		window.open("'.$url.'");
		}
		);
		});
		</script>
		';
		$message = $message . $add_js_newwindows;
	}

	// ajout des appels aux librairies spéciales selon présence des controles spéciaux  
	$add_js = '';
	if (strpos ($message, "plxForms_date")) // date picker
	$add_js .= ' 
	<script type="text/javascript">' . file_get_contents (PLX_PLUGINS.$this->plugName.'/js/FormsDate.js') . '</script>
	'; 
	if (strpos ($message, "plxdatmulti")) { // date picker
	$add_js .= ' 
	<script type="text/javascript" src="'.PLX_PLUGINS.$this->plugName.'/js/plxdatmulti.js?version=' . $versionsite.'"></script>
	<script type="text/javascript" src="'.PLX_PLUGINS.$this->plugName.'/js/jquery-ui.multidatespicker.js?version=' . $versionsite.'"></script>
	<script type="text/javascript">' . file_get_contents (PLX_PLUGINS.$this->plugName.'/js/FormsDate.js') . '</script>
	<script>
	plxdatmulti.to({
		addDates:'.$jsdatavalues.',
		el:".plxdatmulti"
		});
	</script>
	'; 
	}
	// doit être en phase avec le contenu de Formscalcul_param.js du dossier js du plugin
	switch ($formulaire) { 
		case 10:
			$add_js .= ' 
			<script type="text/javascript" src="'.PLX_PLUGINS.$this->plugName.'/js/forms'.$formulaire.'calcul.js?version=' . $versionsite.'"></script>
			';
	}
	if (strpos ($message, "plxPickout")) // liste select par popup
	$add_js .= '
	<script type="text/javascript" src="'.PLX_PLUGINS.$this->plugName.'/js/pickout.js?version=1.9"></script>
	<script>
	pickout.to({
	el:".plxPickout",
	search: false
	});
	pickout.updated({
	el:".plxPickout"
	});
	</script>
	';
	if (strpos ($message, "plxSlidepm")) // liste select par bouton + ou - 
	$add_js .= '
	<script type="text/javascript" src="'.PLX_PLUGINS.$this->plugName.'/js/slidepm.js?version=' . $versionsite.'"></script>
	<script>
	slidepm.to({
	el:".plxSlidepm",
	search: false
	});
	slidepm.updated({
	el:".plxSlidepm"
	});
	</script>
	';
	if (strpos ($message, "plxRadio")) // select par bouton radio
	$add_js .= '
	<script type="text/javascript" src="'.PLX_PLUGINS.$this->plugName.'/js/radioselect.js?version=' . $versionsite.'"></script>
	<script>
	radioselect.to({
	el:".plxRadio",
	search: false
	});
	radioselect.updated({
	el:".plxRadio"
	});
	</script>
	';
	if (strpos ($message, "plxCheckbox")) // check box 
	$add_js .= '
	<script type="text/javascript" src="'.PLX_PLUGINS.$this->plugName.'/js/checkboxselect.js?version=' . $versionsite.'"></script>
	<script>
	checkboxselect.to({
	el:".plxCheckbox",
	search: false
	});
	checkboxselect.updated({
	el:".plxCheckbox"
	});
	</script>
	';
	if (strpos ($message, "plxToggle")) // Toggle slide up ou down 
	$add_js .= '
	<script type="text/javascript" src="'.PLX_PLUGINS.$this->plugName.'/js/plxtoggle.js?version=' . $versionsite.'"></script>
	<script>
	plxtoggle.to({
	el:".plxToggle",
	toggle_open: false
	});
	</script>
	';
	if (strpos ($message, "paypal")) // bouton paypal 
	$add_js .= ' 
	<script type="text/javascript">' . file_get_contents (PLX_PLUGINS.$this->plugName.'/js/paypal.js') . '</script>
	'; 
	// fin  des appels aux librairies spéciales selon présence des controles spéciaux  

	// messages par defaut (peuvent aussi être passés aussi dans $datavalues) 
	$textsuccess = "Votre message a été reçu! Nous vous contactons très rapidement.";
	$textechec = "Votre envoi de message a échoué! Contactez-nous par tél. Merci.";
	$textechechard = "Echec : le serveur ne répond pas! Contactez-nous par tél. Merci.";
	$textewait = "Patientez ";
	if (isset ($datavalues['textsuccess'])) $textsuccess = $datavalues['textsuccess'];
	if (isset ($datavalues['textechec'])) $textechec = $datavalues['textechec'];
	if (isset ($datavalues['textechechard'])) $textechechard = $datavalues['textechechard'];
	if (isset ($datavalues['textewait'])) $textewait = $datavalues['textewait'];

	// ajout du JS nécessaire au pilotage du formulaire
	$add_js .= '
	<script type="text/javascript" src="'.PLX_PLUGINS.$this->plugName.'/js/Forms.js?version=' . $versionsite.'"></script>
	<script type="text/javascript">
	$(document).ready(function(){ 	
				 $("#PlxForm'.$formulaire.'").forms({
						textsuccess:"'.$textsuccess.'",
						textechec:"'.$textechec.'",
						textechechard:"'.$textechechard.'",
						textewait:"'.$textewait.'",
						num_mail:"'.$num_mail.'",
						num_form:"'.$formulaire.'",
						datavalues:'.$jsdatavalues.',
						mailHandlerURL:"'.$mailHandlerURL.'",
						calculHandlerURL:"'.$calculHandlerURL.'",

				})
	   })
	</script>
	';

	$message = $message . $add_js;

	// ajout si des images sont à mettre dans le formulaire
	foreach ($inline_imgs as $data => $value) {	// on remplace les tags des images par l'url asbolue de l'image 
	$message = str_replace("##" . $data . "##", $value, $message, $count); 
	}

	if ($standalone){ 
	// affichage autonome (mode preview en admin) : on ajoute le debut de page html
	$message = $head_html . "<div style='max-width: 768px;margin:auto'>".$message . "</div>";
	}

	// traitement messages data à remplacer dans le html du formulaire
	foreach ($message_data as $data => $value) {
	if(substr($value, 0, 5) === "<?php"){ // la data est en fait un script php à exécuter
	global $plxShowDevis;
	$value = $this->ExecPHP($value, $data, $standalone);
	}
	$message = str_replace("##" . $data . "##", $value, $message);
	};

	// sortie du buffer 
	return ($message);
}

// fonctions utiles
// recherche dans $str entre du contenu entre string delimiteurs 
	public function getContents($str, $startDelimiter, $endDelimiter) {
  $contents = array();
  $startDelimiterLength = strlen($startDelimiter);
  $endDelimiterLength = strlen($endDelimiter);
  $startFrom = $contentStart = $contentEnd = 0;
  while (false !== ($contentStart = strpos($str, $startDelimiter, $startFrom))) {
    $contentStart += $startDelimiterLength;
    $contentEnd = strpos($str, $endDelimiter, $contentStart);
    if (false === $contentEnd) {
      break;
    }
    $contents[] = substr($str, $contentStart, $contentEnd - $contentStart);
    $startFrom = $contentEnd + $endDelimiterLength;
  }
  return $contents;
}
// decoupe en array un string venant des  param xml du configurateur de formulaire (string même vide) 
// $str doit être de la forme : data1|data2\ndata3|data4 etc
// le résultat sera une array (data1 => data2, data3 => data4) etc
// il est possible aussi d'avoir (pour les catId) $str sous la forme data1|data20|data21\ndata3|data40|data41
// dans ce cas dans le retour sera (data1 => data20 => data21, data3 => data40 => data41) 
	public function StringXMLToArray($str='') {
	$separator = "/\r\n|\r|\n/";
	$str = preg_replace($separator, "\n" , $str);
	$str = str_replace ("\n\n", "\n", $str);
	$result = array();
	if(!empty($str)) {
	$arr = explode("\n", $str); 
	foreach ($arr as $key => $value) {
	$line = explode("|", $value);
	if (!array_key_exists(1, $line)) {
	echo ("erreur manque le séparateur | dans ==> " . $value . "<br />");
	}
	else {
		if (!array_key_exists(2, $line)) { // test si 2 separateurs
		$result [$line[0]] = $line[1];
		}
		else {
		$result [$line[0]] = array ($line[1] => $line[2]);
		}
	}
	}
	}
	return $result;
}
//  fonction qui ecrit en xml le contenu  d'une  table POST (venant d'un formulaire)
	public function Post2Xmlfile($post="", $form="", $document="", $file="") {
	if ($document == "") {$document = "formulaire";}
	$xw = xmlwriter_open_memory();
	xmlwriter_set_indent($xw, 1);
	$res = xmlwriter_set_indent_string($xw, ' ');
	xmlwriter_start_document($xw, '1.0', 'UTF-8');
	xmlwriter_start_element($xw, $document);
	foreach ($post as $tag => $value) {
	xmlwriter_start_element($xw, $tag);
	if (is_array ($value)) error_log("error : ". json_encode($value), 0);
	if (!is_array ($value)) xmlwriter_write_cdata($xw, $value);
	xmlwriter_end_element($xw);
	};
	xmlwriter_end_element($xw);
	$xml = xmlwriter_output_memory($xw, true);
	if ($file == "") {$file = PLX_ROOT."core/admin/"."Formulaire-".$form. "-" . date('d-F-Y-H-i').".xml";}
    $fp = fopen($file, "wb+");
    if (fwrite($fp, $xml) != false) {
		if (!fclose($fp)) {
			return false;
		}
		return true;
	}
	else {
		return false;
	}
}
//  fonction qui execute du code php 
//	$script_php : string contenant le code php (y compris les balises debut et fin  php)
//	return : le résutat du script 
	public function ExecPHP($script_php="", $data="tempdata", $standalone=false) {
	//attention au quote et double quote dans le contenu.
	//remplacer ceq quotes et double quote par &lsquo; et &ldquo; lorsqu'il s'agit de contenu html
	if (!file_exists($file_exec=PLX_PLUGINS.$this->plugName."/ExecPHP/".$data.".php") || $standalone)
		{file_put_contents($file_exec, $script_php);};
	ob_start();
	include ($file_exec);
	$result = ob_get_clean();
	return $result;
}
}
?>